/* Original code from SHIMODA Hiroshi's Open Bookmarks in New Tab
   This may be the best code for opening bookmark in new tab so far
   modified for Tab Mix Lite by Hemiola SUN
*/

var TM_OpenBookmarksInNewTab = {
  init : function() {
    if (!("PlacesUIUtils" in window)) 
      return;

    if( !PlacesUIUtils.__TM_openBookMarksInNewTab_done ) {
      // we cannot use TabMixLib.codeHook() here (see tmlib.js)
      // otherwise, error will occures.
      // bug reproduce:
      //   open 2 firefox windows
      //   change into private browsing
      //   click on bookmarks button
      //   nothing happens and error message shows in console
      eval('PlacesUIUtils.openNodeWithEvent = '+
        PlacesUIUtils.openNodeWithEvent.toSource().replace(
          /(([^\s]*)whereToOpenLink\(aEvent\))/,
          '$2TM_OpenBookmarksInNewTab.convertWhereToOpenLink($1, null, aNode)'
        )
      );

      eval('PlacesUIUtils._openTabset = '+
        PlacesUIUtils._openTabset.toSource().replace(
          'if (where == "window") {',
          <![CDATA[
            where = browserWindow.TM_OpenBookmarksInNewTab.convertWhereToOpenLink(where, aEvent);
            $&
          ]]>
        )
      );
    }
    PlacesUIUtils.__TM_openBookMarksInNewTab_done = true;
  },

  convertWhereToOpenLink : function( aWhere, aEvent, aNode )  {
    var pref = Services.prefs.getBranch("extensions.tabmix.");

    if ( aEvent && 
         ( ( aEvent.target.localName == "treechildren" && aEvent.currentTarget.selectedNode &&
             !PlacesUtils.nodeIsURI(aEvent.currentTarget.selectedNode) &&
             PlacesUtils.nodeIsContainer(aEvent.currentTarget.selectedNode) ) ||
           ( aEvent.originalTarget && aEvent.originalTarget.node &&
             PlacesUtils.nodeIsContainer(aEvent.originalTarget.node) ) ) )
      return aWhere;

    if ( aNode && PlacesUtils.nodeIsURI(aNode) && PlacesUIUtils.checkURLSecurity(aNode) &&
         PlacesUtils.nodeIsBookmark(aNode) &&
         (  aNode.uri.indexOf("javascript:") == 0 ||
            ( PlacesUtils.annotations.itemHasAnnotation( aNode.itemId, "bookmarkProperties/loadInSidebar" ) &&
              Components.classes["@mozilla.org/appshell/window-mediator;1"]
                        .getService(Components.interfaces.nsIWindowMediator)
                        .getMostRecentWindow("navigator:browser") ) ) )
      return aWhere;

    var browserWindow = getTopWin();
    if ( !browserWindow ||
         ( browserWindow.gBrowser.currentURI.spec == "about:blank" &&
           browserWindow.gBrowser.selectedTab.getAttribute("busy") != "true" ) )
      return aWhere;

    switch (aWhere) {
      case "current":
        return pref.getBoolPref("opentabfor.places") ? "tab" : aWhere;
      case "tab":
        return pref.getBoolPref("opentabfor.places") ? "current" : aWhere;
      default:
        return aWhere;
    }
  },
  
  handleEvent : function (aEvent) {
    switch (aEvent.type) {
      case "load":
        window.removeEventListener("load", this, false);
        this.init();
        return;
    }
  }
};

window.addEventListener("load", TM_OpenBookmarksInNewTab, false);
