/*
 * tmlib.js
 *
 */


var TabMixLib = {

  /*
   * Function for debug
   */
  msg : function (message) {
    var d = new Date();
    Application.console.log("Tab Mix Lite: " + d.toString() + ") :" + message);
  },
  
  // Original function from Tab Utilities
  //
  codeHook : function ( aFunc, oldCode, newCode ) {
    switch (oldCode) {
      case "{":
        oldCode = /^.*{/;
        newCode = "$&" + newCode;
        break;
      case "}":
        oldCode = /}$/;
        newCode = newCode + "$&";
        break;
    }
  
    try {
      eval( aFunc + "=" + eval(aFunc).toString().replace(oldCode, newCode) );
    }
    catch (e) { 
      this.msg( "eval error: "+ aFunc.toString() );
    }
  },
  
  // if aValue = null, return its value
  setCSS : function ( aStyleSheet, aSelector, aProperty, aValue ) {
    aValue = aValue || null;
    let browserCSS;
    for ( let i = 0; i < document.styleSheets.length; ++i ) {
      if ( document.styleSheets[i].href == aStyleSheet ) {
        browserCSS = document.styleSheets[i];
        break;
      }
    }
    if ( browserCSS ) {
      let rules = browserCSS.cssRules;
      for (let i = 0; i < rules.length; ++i) {
        let rule = rules[i];
        if ( rule.cssText.indexOf(aSelector) > -1 ) {
          if (aValue) {
            rule.style.setProperty( aProperty, aValue, null );
            return true;
          }
          else
            return rule.style.getPropertyValue(aProperty);
        }
      }
    }
    return aValue ? false : null;
  },
  
  notification : function () {
    window.getAttention();
  }
  
} // End of TabMixLib
